package de.ozgcloud.nachrichten.common.vorgang;

import java.util.stream.Stream;

import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Service;

import de.ozgcloud.nachrichten.NachrichtenManagerConfiguration;
import lombok.RequiredArgsConstructor;

@Service(NachrichtenManagerConfiguration.NACHRICHTEN_VORGANG_SERVICE)
@RequiredArgsConstructor
public class VorgangService {

	@Qualifier(NachrichtenManagerConfiguration.NACHRICHTEN_VORGANG_REMOTE_SERVICE)
	private final VorgangRemoteService remoteService;

	public Stream<String> findVorgangIds(String servicekontoType, String postfachId) {
		return remoteService.findVorgangIds(servicekontoType, postfachId);
	}

	public Vorgang getVorgang(String vorgangId) {
		return remoteService.getVorgang(vorgangId);
	}
}
