package de.ozgcloud.nachrichten.email;

import static org.junit.jupiter.api.Assertions.*;

import jakarta.validation.ConstraintViolationException;

import org.junit.jupiter.api.Nested;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.function.Executable;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.mock.mockito.MockBean;
import org.springframework.test.context.TestPropertySource;

import de.ozgcloud.apilib.common.callcontext.OzgCloudCallContextAttachingInterceptor;
import de.ozgcloud.common.test.ITCase;

@ITCase
class MailServiceITCase {

	@Autowired
	private MailService mailService;

	@MockBean
	private OzgCloudCallContextAttachingInterceptor interceptor;

	@MockBean
	private EmailGrpcService emailGrpcService;

	@Nested
	class TestSendMail {

		@Test
		void shouldThrowConstraintViolationException() {
			Executable callSendMailWithoutRecipients = () -> mailService
					.sendMail(MailSendRequestTestFactory.createBuilder().clearToAddresses().build());

			assertThrows(ConstraintViolationException.class, callSendMailWithoutRecipients);
		}

		@Test
		void shouldNotThrowException() {
			Executable callSendMailWithoutRecipients = () -> mailService
					.sendMail(MailSendRequestTestFactory.create());

			assertDoesNotThrow(callSendMailWithoutRecipients);
		}
	}
}
